#include "nds_asm.h"
#include "equates.h"
#include "ARMZ80/z80mac.h"
//#include "ARMZ80/armz80.h"

	.arm
	.align 4
	.section .text

	.global loadcart
	.global HuMapper_
	.global packState
	.global unpackState
	.global emuflags
	.global romstart
	.global romnum
//	.global scaling
	.global cartflags
	.global g_dipswitch0
	.global g_dipswitch1
	.global g_dipswitch2
	.global coincounter0
	.global coincounter1
	.global vrombase0
	.global vrombase1
	.global prombase
	.global goemon

	.global SCRL_RAM
	.global EMU_RAM
	.global ROM_Space
rawrom:
/*
	.incbin "gberet/577l03.10c"
	.incbin "gberet/577l02.8c"
	.incbin "gberet/577l01.7c"
	.incbin "gberet/577l07.3f"
	.incbin "gberet/577l06.5e"
	.incbin "gberet/577l05.4e"
	.incbin "gberet/577l08.4f"
	.incbin "gberet/577l04.3e"
	.incbin "gberet/577h09.2f"
	.incbin "gberet/577h10.5f"
	.incbin "gberet/577h11.6f"

	.incbin "gberet/621d01.10c"
	.incbin "gberet/621d02.12c"
	.incbin "gberet/621a05.6d"
	.incbin "gberet/621d03.4d"
	.incbin "gberet/621d04.5d"
	.incbin "gberet/621a06.5f"
	.incbin "gberet/621a07.6f"
	.incbin "gberet/621a08.7f"
*/
;@----------------------------------------------------------------------------
loadcart: 		;@ called from C:  r0=rom number, r1=emuflags
;@----------------------------------------------------------------------------
	stmfd sp!,{r0-r1,r4-r11,lr}

	ldr z80optbl,=Z80_optable
@	ldr r1,=findrom
@	bl thumbcall_r1
//	ldr r3,=rawrom
	ldr r3,=ROM_Space

	ldmfd sp!,{r0-r1}
	str r0,romnum
	str r1,emuflags

								;@ r3=rombase til end of loadcart so DON'T FUCK IT UP
//	mov r2,#1
//	str r2,goemon
	ldr r2,goemon
	cmp r2,#0
	str r3,romstart				;@ set rom base
	add r0,r3,#0xC000			;@ 0xC000
	addne r0,r0,#0x4000			;@ Mr. Goemon
	str r0,vrombase0			;@ bg
	add r0,r0,#0x4000
	str r0,vrombase1			;@ spr
	add r0,r0,#0x10000
	str r0,prombase				;@ colour prom

	ldr r4,=MEMMAPTBL_
	ldr r5,=RDMEMTBL_
	ldr r6,=WRMEMTBL_
	ldr r7,=rom_R0
	ldr r8,=rom_W
	mov r0,#0

tbloop1:
;@	and r1,r0,r2
	add r1,r3,r0,lsl#13
	str r1,[r4,r0,lsl#2]
	str r7,[r5,r0,lsl#2]
	str r8,[r6,r0,lsl#2]
	add r0,r0,#1
	cmp r0,#0x88
	bne tbloop1
resbg:
	ldr r7,=empty_R
	ldr r8,=empty_W
tbloop2:
	str r3,[r4,r0,lsl#2]
	str r7,[r5,r0,lsl#2]
	str r8,[r6,r0,lsl#2]
	add r0,r0,#1
	cmp r0,#0x100
	bne tbloop2


	ldr r1,=EMU_RAM
	ldr r7,=rom_R0
	ldr r8,=ram_W
	mov r0,#0xF8				;@ RAM
meml3:
	str r1,[r4,r0,lsl#2]		;@ MemMap
	str r7,[r5,r0,lsl#2]		;@ RdMem
	str r8,[r6,r0,lsl#2]		;@ WrMem
	add r0,r0,#1				;@ 0xF8-0xFB RAM
	cmp r0,#0xFB
	bne meml3

	ldr r7,=IO_R
	ldr r8,=IO_W
	mov r0,#0xFF				;@ IO
	str r7,[r5,r0,lsl#2]		;@ RdMem
	str r8,[r6,r0,lsl#2]		;@ WrMem


	mov z80pc,#0				;@ (eliminates any encodePC errors during mapper*init)
	store_lastbank z80pc

	adr r4,HuMapData
	mov r5,#0x80
HuDataLoop:
	mov r0,r5
	ldrb r1,[r4],#1
	bl HuMapper_
	movs r5,r5,lsr#1
	bne HuDataLoop

	ldr r0,=SCRL_RAM			;@ clear RAM
	mov r1,#0		
	mov r2,#0x2040/4
	bl memset_

	bl GFX_reset
	bl IO_reset
	bl Sound_reset
	bl CPU_reset
	ldmfd sp!,{r4-r11,lr}
	bx lr
;@----------------------------------------------------------------------------
HuMapData:
	.byte 0xFF,0xF8,0x05,0x04,0x03,0x02,0x01,0x00			;@ Green Beret
;@	.byte 0x07,0x06,0x05,0x04,0x01,0x00,0xFF,0xF8			;@ Renegade
;@	.byte 0x00,0x00,0x00,0xF7,0x00,0x00,0xF8,0xFF			;@ PC-Engine
;@----------------------------------------------------------------------------
;@----------------------------------------------------------------------------
packState:	;@ called from ui.c.
;@int packState(u32 *statePtr), copy state to <here>, return size
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r5,z80optbl,lr}
	ldr z80optbl,=Z80_optable

	mov r12,r0					;@ r6=where to copy state
	ldr r2,romstart
	rsb r2,r2,#0				;@ adjust rom maps,etc so they aren't based on rombase
	bl fixromptrs				;@ (so savestates are valid after moving roms around)

	mov r0,#0					;@ r0 holds total size (return value)

	adr r4,savelst				;@ r4=list of stuff to copy
	mov r3,#(lstend-savelst)/8	;@ r3=items in list
ss1:
	ldmia r4!,{r1,r2}			;@ r1=what to copy, r2=how much to copy
	add r0,r0,r2
ss0:
	ldr r5,[r1],#4
	str r5,[r12],#4
	subs r2,r2,#4
	bne ss0
	subs r3,r3,#1
	bne ss1

	ldr r2,romstart
	bl fixromptrs

	ldmfd sp!,{r4-r5,z80optbl,lr}
	bx lr

savelst:	.long rominfo,8,SCRL_RAM,0x2040,cpustate,96,gfxstate,8
lstend:

fixromptrs:						;@ add r2 to some things
	load_lastbank r1
	add r1,r1,r2
	store_lastbank r1

	ldr r1,[z80optbl,#z80_regs+6*4]	;@ Z80 PC
	add r1,r1,r2
	str r1,[z80optbl,#z80_regs+6*4]	;@ Z80 PC

	bx lr
;@----------------------------------------------------------------------------
unpackState:	;@ called from ui.c
;@ void unpackState(u32* stateptr)	 (stateptr must be word aligned)
;@----------------------------------------------------------------------------
	stmfd sp!,{r4-r5,z80optbl,lr}
	ldr z80optbl,=Z80_optable

	mov r4,#(lstend-savelst)/8	;@ read entire state
	adr r3,savelst
ls1:
	ldmia r3!,{r1,r2}
ls0:
	ldr r5,[r0],#4
	str r5,[r1],#4
	subs r2,r2,#4
	bne ls0
	subs r4,r4,#1
	bne ls1

	ldr r2,romstart				;@ adjust ptr shit (see savestate above)
	bl fixromptrs

	mov r0,#1
	ldr r1,=sprmemreload
	strb r0,[r1]

	ldmfd sp!,{r4-r5,z80optbl,lr}
	bx lr



;@----------------------------------------------------------------------------
//	.section itcm
;@----------------------------------------------------------------------------

;@----------------------------------------------------------------------------
HuMapper_:		;@ rom paging..
;@----------------------------------------------------------------------------
	stmfd sp!,{r3-r7}
	ldr r6,=MEMMAPTBL_
	ldr r2,[r6,r1,lsl#2]!
	ldr r3,[r6,#-1024]			;@ RDMEMTBL_
	ldr r4,[r6,#-2048]			;@ WRMEMTBL_

	mov r5,#0
	cmp r1,#0xFC
	movmi r5,#12

wr_tbl:
	get_readmem_tbl r6
	tst r0,#0xFF
	bne memaps					;@ safety
	b flush
memapl:
	add r6,r6,#4
memap2:
	add r3,r3,r5
	sub r2,r2,#0x2000
memaps:
	movs r0,r0,lsr#1
	bcc memapl					;@ C=0
	strcs r3,[r6],#4			;@ readmem_tbl
	strcs r4,[r6,#28]			;@ writemem_tb
	strcs r2,[r6,#60]			;@ memmap_tbl
	bne memap2

;@------------------------------------------
flush:		;@ update cpu_pc & lastbank
;@------------------------------------------
	reencodePC

	ldmfd sp!,{r3-r7}
	bx lr


;@----------------------------------------------------------------------------

romstart:
	.long 0
romnum:
	.long 0						;@ romnumber
rominfo:						;@ keep emuflags/BGmirror together for savestate/loadstate
emuflags:
	.byte 0						;@ emuflags      (label this so UI.C can take a peek) see equates.h for bitfields
//scaling:
	.byte SCALED				;@ (display type)
	.byte 0,0					;@ (sprite follow val)
cartflags:
	.byte 0 					;@ cartflags
g_dipswitch0:
	.byte 0
g_dipswitch1:
	.byte 0x85					;@ lives, cabinet & demo sound.
g_dipswitch2:
	.byte 0
coincounter0:
	.long 0
coincounter1:
	.long 0
vrombase0:
	.long 0
vrombase1:
	.long 0
prombase:
	.long 0
goemon:
	.long 0
	.pool
	.section .bss
SCRL_RAM:
	.space 0x0040
EMU_RAM:
	.space 0x2000
WRMEMTBL_:
	.space 256*4
RDMEMTBL_:
	.space 256*4
MEMMAPTBL_:
	.space 256*4
ROM_Space:
	.space 0x24220

;@----------------------------------------------------------------------------


