#include "equates.h"
#include "nds_asm.h"
#include "SN76496\sn76496_equ.h"

	.global Sound_init
	.global Sound_reset
	.global Vbl_Sound_2
	.global SN_0_W
	.global SN76496_0
	.extern pauseEmulation


;@----------------------------------------------------------------------------

	.arm
	.align 4
	.section .text

;@----------------------------------------------------------------------------
Sound_init:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}

	ldr r0,=SN76496_0
	mov r1,#1
	bl SN76496_set_mixrate		;@ sound, 0=low, 1=high mixrate
	ldr r1,=1536000
	bl SN76496_set_frequency	;@ sound, chip frequency
	ldr r1,=FREQTBL
	bl SN76496_init				;@ sound

	ldmfd sp!,{lr}
//	bx lr

;@----------------------------------------------------------------------------
Sound_reset:
;@----------------------------------------------------------------------------
	stmfd sp!,{lr}
	ldr r0,=SN76496_0
	ldr r1,pcmptr0
	str r1,[r0,#pcmptr]
	bl SN76496_reset			;@ sound
	ldmfd sp!,{lr}
	bx lr

;@----------------------------------------------------------------------------
Vbl_Sound_2:				;@ r0=length, r1=pointer
;@----------------------------------------------------------------------------
;@	mov r11,r11
	stmfd sp!,{r0,r1,lr}

	ldr r1,=pauseEmulation		;@ Output silence when emulation paused.
	ldr r1,[r1]
	cmp r1,#0
	bne silenceMix

	mov r1,r0
	ldr r0,=SN76496_0
	str r1,[r0,#mixlength]
	bl SN76496_mixer

	ldmfd sp!,{r0,r1}
	mov r12,r0
	ldr r3,pcmptr0
wavloop:
	ldrb r2,[r3],#1
	mov r2,r2,lsl#8
	orr r2,r2,r2,lsl#16
	str r2,[r1],#4
	subs r12,r12,#1
	bhi wavloop

	ldmfd sp!,{lr}
	bx lr

silenceMix:
	ldmfd sp!,{r0,r1}
	mov r12,r0
	mov r2,#0
silenceLoop:
	str r2,[r1],#4
	subs r12,r12,#1
	bhi silenceLoop

	ldmfd sp!,{lr}
	bx lr

;@----------------------------------------------------------------------------
SN_0_W:
;@----------------------------------------------------------------------------
	stmfd sp!,{r3,lr}
	mov r1,r0
	ldr r0,=SN76496_0
	bl SN76496_w
	ldmfd sp!,{r3,lr}
	bx lr

;@----------------------------------------------------------------------------

pcmptr0:	.long WAVBUFFER
pcmptr1:	.long WAVBUFFER+528

	.section .bss
SN76496_0:
	.space 72
FREQTBL:
	.space 1024*2
WAVBUFFER:
	.space 0x1000
;@----------------------------------------------------------------------------
	.end
